
  #Dim All
  #Include "win32api.inc"


  %WM_FORWARDMSG = &H37F ' (895)
  %ID_OCX = 1001
  Global hOcx As Dword

' *********************************************************************************************
  Declare Function AtlAxWinInit Lib "ATL.DLL" Alias "AtlAxWinInit" () As Long
' *********************************************************************************************
  Declare Function AtlAxWinTerm () As Long
' *********************************************************************************************
  Function AtlAxWinTerm () As Long
    UnregisterClass ("AtlAxWin", GetModuleHandle(ByVal %NULL))
  End Function
' *********************************************************************************************
' **********************************************************************************************
  Declare Function AtlAxGetControl Lib "ATL.DLL" Alias "AtlAxGetControl" _
     ( _
     ByVal hWnd As Dword, _   ' [in] A handle to the window that is hosting the control.
     ByRef pp As Dword _      ' [out] The IUnknown of the control being hosted.
  ) As Dword
' *********************************************************************************************

' *********************************************************************************************
' Puts the address of an object in a variant and marks it as containing a dispatch variable
' *********************************************************************************************
  Sub AtlMakeDispatch ( _
     ByVal lpObj As Dword, _                        ' Address of the object instance
     ByRef vObj As Variant _                        ' Variant to contain this address
     ) Export

     Local lpvObj As VARIANTAPI Ptr                 ' Pointer to a VARIANTAPI structure
     Let vObj = Empty                               ' Make sure is empty to avoid memory leaks
     lpvObj = VarPtr(vObj)                          ' Get the VARIANT address
     @lpvObj.vt = %VT_Dispatch                      ' Mark it as containing a dispatch variable
     @lpvObj.vd.pdispVal = lpObj                    ' Set the dispatch pointer address

  End Sub
' *********************************************************************************************

' *********************************************************************************************
' Main dialog callback
' *********************************************************************************************
  CallBack Function MainDlgProc()

     Local rc As RECT
     Local r As Long
     Local x As Long
     Local y As Long
     Local xx As Long
     Local yy As Long

     Select Case CbMsg

        Case %WM_SIZE
           GetClientRect CbHndl, rc
           x = rc.nLeft
           y = rc.nTop
           xx = rc.nRight - rc.nLeft
           yy = rc.nBottom - rc.nTop
           MoveWindow hOcx, x, y, xx, yy, %TRUE

        Case %WM_DESTROY
           PostQuitMessage 0

        Case %WM_COMMAND
           Select Case CbCtl
              Case %IDCANCEL
                 If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
                    Dialog End CbHndl, 0
                 End If
           End Select

     End Select

  End Function
' *********************************************************************************************

' *********************************************************************************************
' Main
' *********************************************************************************************
  Function PBMain

     Local oOcx As Dispatch
     Local oHtml As Dispatch
     Local hDlg As Dword
     Local hr As Dword
     Local OcxName As Asciiz * 255
     Local pUnk As Dword
     Local uMsg As tagMsg
     Local vVar As Variant
     Local vRes As Variant
     Local s As String

     OcxName = "Shell.Explorer"

     AtlAxWinInit   ' // Initializes ATL

     Dialog New 0, "HTML document test",,, 528, 334, %WS_OVERLAPPEDWINDOW, 0 To hDlg
     Control Add "AtlAxWin", hDlg, %ID_OCX, OcxName, 0, 0, 0, 0, %WS_VISIBLE Or %WS_CHILD Or %WS_BORDER

     ' // Get the handle of the control
     Control Handle hDlg, %ID_OCX To hOcx
     ' // Get the interface pointer of the WebBrowser control
     AtlAxGetControl(hOcx, pUnk)
     ' // Make a dispatch variant from it to be able to use PB automation
     AtlMakeDispatch(pUnk, vVar)
     Set oOcx = vVar

     ' // Create an empty Html document
     vVar = "about:blank"
     Object Call oOcx.Navigate(vVar)

     ' // Get his interface pointer
     Object Get oOcx.Document To vRes
     Set oHtml = vRes

     ' // Make an Html form

     s = "<head><title>Register your Purchase</title></head>" & $CrLf
     s = s & "<body>" & $CrLf
     s = s & "<center>" & $CrLf
     s = s & "<table WIDTH=" & $Dq & "95%" & $Dq & " BORDER=0 CELLPADDING=0 CELLSPACING=0><tr><td>" & $CrLf
     s = s & "<font FACE=" & $Dq & "Arial,Verdana" & $Dq & ">" & $CrLf
     s = s & "<h1 ALIGN=CENTER>Registration Info</h1>" & $CrLf
     s = s & "<center><font color=red><b><i>Not for registering PowerBASIC You must" & $CrLf
     s = s & "<a href=" & $Dq & "https://www.powerbasic.com/" & $Dq & ">order PowerBasic</a> to register it.</i></b></font></center>" & $CrLf
     s = s & "<p><center>" & $CrLf
     s = s & "<table WIDTH=" & $Dq & "95%" & $Dq & " BORDER=1 CELLPADDING=0 CELLSPACING=0>" & $CrLf
     s = s & "<tr BGCOLOR=" & $Dq & "#DDDDDD" & $Dq & "><td ALIGN=CENTER>" & $CrLf
     s = s & "<br><h2 ALIGN=CENTER>Please enter your Contact Information</h2>" & $CrLf
     s = s & "<table WIDTH=" & $Dq & "100%" & $Dq & " BORDER=0 CELLPADDING=1 CELLSPACING=1>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "First Name:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "firstname" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "Last Name:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "lastname" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "E-Mail Address:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "email" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "Company Name:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "company" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "Mailing Address:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "address1" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & " " & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "address1" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "City:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "city" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "State:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "state" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "Zip/Postal Code:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "postal" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "Country:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "country" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "Phone:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "phone" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "Fax:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "fax" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "<tr><td ALIGN=RIGHT>" & $CrLf
     s = s & "Where purchased:" & $CrLf
     s = s & "</td><td>" & $CrLf
     s = s & "<input TYPE=TEXT NAME=" & $Dq & "where" & $Dq & " VALUE=" & $Dq & "" & $Dq & " SIZE=40>" & $CrLf
     s = s & "</td></tr>" & $CrLf

     s = s & "</font>" & $CrLf
     s = s & "</table>" & $CrLf
     s = s & "</center>" & $CrLf
     s = s & "</body>" & $CrLf

     ' // Write the Html string
     vVar = s
     Object Call oHtml.Write(vVar)

     ' // Close the document
     Object Call oHtml.Close
     Set oHtml = Nothing

'     SetFocus(hOcx)
'     DIALOG SHOW MODAL hDlg, CALL MainDlgProc TO hr

     SetFocus(hOcx)
     Dialog Show Modeless hDlg, Call MainDlgProc To hr


     While GetMessage(uMsg, %NULL, 0, 0)
        '// Pass keyboard messages to the ancestor
        '// Returns 0 if the message was not processed, nonzero if it was
        If SendMessage(hOcx, %WM_FORWARDMSG, 0, VarPtr(uMsg)) = 0 Then
           If IsDialogMessage(hDlg, uMsg) = %FALSE Then
              TranslateMessage uMsg
              DispatchMessage uMsg
           End If
        End If
     Wend

     AtlAxWinTerm   ' // Uninitializes ATL
     Set oOcx = Nothing

  End Function
' *********************************************************************************************
